function [cpole, sigma_cpole] = Fit_Cavpole_RefCav( Cav, Cav_Sigma, varargin )

if mnismember(varargin,'Plot')
    doplot = 'Plot';
else
    doplot = 'noPlot';
end

Freq = containers.Map;
Abs = containers.Map;
Phase = containers.Map;
temp_Sigma = containers.Map;
temp_FitParam = containers.Map;
temp_Fitting = containers.Map;
c = 299792458;

% importdata
data = importdata('cavpolegain.CSV');
Freq('Cavpole_RefCav') = data.data(:,1);
Abs('Cavpole_RefCav') = 10.^(data.data(:,2)/20);
data = importdata('cavpolephase.CSV');
Phase('Cavpole_RefCav') = data.data(:,2);
% model RefCav
% m_refcav = tf(1e-1,[1/(84e3*2*pi) 1]);
m_refcav = zpk(-400e3*2*pi,-[(70e3*2*pi) 350e3*2*pi],45e3);
% 70kHz is a optical pole of the reference cavity and pole and zero around
% 400kHz would be the pole of DC PDs. 
[temp_Fitting('Cavpole_Refcav'),~] = TF_Fit(Freq('Cavpole_RefCav'),Abs('Cavpole_RefCav'),Phase('Cavpole_RefCav'),...
    m_refcav,[1],[1 2],temp_Sigma,'Cavpole_Refcav',temp_FitParam,doplot,'title','Cavity pole estimation');

saveas(gcf,'figure/Cavpole_Refcav.pdf')

cpole = abs(temp_FitParam('Cavpole_Refcav_pole1'));
sigma_cpole = abs(temp_Sigma('Cavpole_Refcav_pole1'));
Cav('Finnese_RefCav') = c/(4*10e-2*cpole);
Cav_Sigma('Finnese_RefCav') = Cav('Finnese_RefCav')*sigma_cpole/cpole;
Cav('r_RefCav') = (-pi+sqrt(pi^2+4*Cav('Finnese_RefCav')^2))/2/Cav('Finnese_RefCav');
Cav('R_RefCav') = Cav('r_RefCav')^2;
Cav('T_RefCav') = 1 - Cav('R_RefCav');
F = Cav('Finnese_RefCav');
Cav_Sigma('r_RefCav') = Cav('r_RefCav')*(1/(-pi+sqrt(pi^2+4*F^2))*4*F/sqrt(pi^2+4*F^2)-1/F)*Cav_Sigma('Finnese_RefCav');
Cav_Sigma('R_RefCav') = 2*Cav('R_RefCav')*Cav_Sigma('r_RefCav');
Cav_Sigma('T_RefCav') = Cav_Sigma('R_RefCav');
Cav('L_RefCav') = Cav('T_RefCav')-0.000093189;
Cav_Sigma('L_RefCav') = Cav_Sigma('T_RefCav');

Cav('FSR_RefCav') = c/2/100e-3;

end

