function [H, sigma_H, Cav_LPF, dt, sigma_dt] = Fit_Himc_0901(RTS, FitServo_0dB, Act, Cav, varargin)

if mnismember(varargin,'Plot')
    doplot = 'Plot';
else
    doplot = 'noPlot';
end

Freq = containers.Map;
Abs = containers.Map;
Phase = containers.Map;
Servo = containers.Map;

% Servo model
IN1GAIN = mn_CMSgain(-10);
RTS('K1IMC-MCL_SERVO_GAIN') = -0.2;
Servo('CMS_AOM') = FitServo_0dB('CMS_AOM')*10^(IN1GAIN/20);
Servo('CMS_SUS') = FitServo_0dB('CMS_SUS_analog')*FitServo_0dB('CMS_SUS_digital')*10^(IN1GAIN/20)*RTS('K1IMC-MCL_SERVO_GAIN');

% FSS OLG
fast_pol = -1;
CG = 30;
FG = 30;
Servo('TTFSS_PZT') = FitServo_0dB('TTFSS_PZT')*10^(CG/20)*10^(FG/20)*fast_pol;
Servo('TTFSS_EOM') = FitServo_0dB('TTFSS_EOM')*10^(CG/20);
olg_fss = Cav('LPF_RefCav_0901')*Cav('Mixer_RefCav')*(Servo('TTFSS_PZT')*Act('NPRO_PZT')+Servo('TTFSS_EOM')*Act('BEOM'));

m_AS = Servo('CMS_AOM')*Act('AOM')*olg_fss/(1+olg_fss);

fit_H = zeros(1,10);
fit_sigma_H = zeros(1,10);
fit_dt = zeros(1,10);
fit_sigma_dt = zeros(1,10);
for ii = 1:10
    mnimportdata(['O0901_' num2str(ii+30) '.CSV'],Freq,Abs,Phase,['OLG_IMC' num2str(ii)],'tf');
%     c_olg = mnbode_list(olg_model,Freq(['OLG_IMC' num2str(ii)]),'c');
%     mnbode(Freq(['OLG_IMC' num2str(ii)]),Abs(['OLG_IMC' num2str(ii)]),Phase(['OLG_IMC' num2str(ii)]),...
%         'linestyle',{'*'})
    [~,fitabs] = mntrim(0,1e5,Freq(['OLG_IMC' num2str(ii)]),Abs(['OLG_IMC' num2str(ii)]));
    [fitff,fitphase] = mntrim(0,1e5,Freq(['OLG_IMC' num2str(ii)]),Phase(['OLG_IMC' num2str(ii)]));
    [fit_H(ii), fit_sigma_H(ii), ~, fit_dt(ii), fit_sigma_dt(ii)]...
    = Fit_Opgain(fitff, fitabs,fitphase,...
    Cav, 'IMC', 1e-6, m_AS , doplot);

end
H = mean(fit_H);
sigma_H = std(fit_H);
dt = mean(fit_dt);
sigma_dt = std(fit_dt);
Cav_LPF = tf(H,[1/Cav('Cpole_IMC')/2/pi 1]);