function [H, sigma_H, Cav_LPF, dt, sigma_dt] = Fit_Himc_1122(RTS, FitServo_0dB, Act, Cav, varargin)

if mnismember(varargin,'Plot')
    doplot = 'Plot';
else
    doplot = 'noPlot';
end

Freq = containers.Map;
Abs = containers.Map;
Phase = containers.Map;
Servo = containers.Map;

% Servo model
IN1GAIN = mn_CMSgain(-20);
RTS('K1IMC-MCL_SERVO_GAIN') = -40;
Servo('CMS_AOM') = FitServo_0dB('CMS_AOM')*10^(IN1GAIN/20);
Servo('CMS_SUS') = FitServo_0dB('CMS_SUS_analog_susonly')*FitServo_0dB('CMS_SUS_digital_susonly')...
    *10^(IN1GAIN/20)*RTS('K1IMC-MCL_SERVO_GAIN');


m_AS = Servo('CMS_SUS')*Act('MCEsus');

mnimportdata('O1122_9.txt',Freq,Abs,Phase,'OLG_IMC','tf');
%     c_olg = mnbode_list(olg_model,Freq(['OLG_IMC' num2str(ii)]),'c');
%     mnbode(Freq(['OLG_IMC' num2str(ii)]),Abs(['OLG_IMC' num2str(ii)]),Phase(['OLG_IMC' num2str(ii)]),...
%         'linestyle',{'*'})
[~,fitabs] = mntrim(0,1e5,Freq('OLG_IMC'),Abs('OLG_IMC'));
[fitff,fitphase] = mntrim(0,1e5,Freq('OLG_IMC'),Phase('OLG_IMC'));
[H, sigma_H, Cav_LPF, dt, sigma_dt]...
= Fit_Opgain(fitff, fitabs,fitphase,Cav, 'IMC', 4.495e-6, m_AS , doplot);

end