function [H, sigma_H, Cav_LPF, dt, sigma_dt] = Fit_Himc_1124(RTS, FitServo_0dB, Act, Cav, varargin)

if mnismember(varargin,'Plot')
    doplot = 'Plot';
else
    doplot = 'noPlot';
end

Freq = containers.Map;
Abs = containers.Map;
Phase = containers.Map;
Servo = containers.Map;

% Servo model
IN1GAIN = mn_CMSgain(-20);
RTS('K1IMC-MCL_SERVO_GAIN') = -0.1;
Servo('CMS_AOM') = FitServo_0dB('CMS_AOM')*10^(IN1GAIN/20);
Servo('CMS_SUS') = FitServo_0dB('CMS_SUS_analog')*FitServo_0dB('CMS_SUS_digital')*10^(IN1GAIN/20)*RTS('K1IMC-MCL_SERVO_GAIN');

% FSS OLG
fast_pol = -1;
CG = 26;
FG = 30;
Servo('TTFSS_PZT') = FitServo_0dB('TTFSS_PZT')*10^(CG/20)*10^(FG/20)*fast_pol;
Servo('TTFSS_EOM') = FitServo_0dB('TTFSS_EOM')*10^(CG/20);
olg_fss = Cav('LPF_RefCav_1124')*Cav('Mixer_RefCav')*(Servo('TTFSS_PZT')*Act('NPRO_PZT')+Servo('TTFSS_EOM')*Act('BEOM'));

m_AS = Servo('CMS_AOM')*Act('AOM')*olg_fss/(1+olg_fss);

mnimportdata('O1124_11.txt',Freq,Abs,Phase,'OLG_IMC','tf');
%     c_olg = mnbode_list(olg_model,Freq(['OLG_IMC' num2str(ii)]),'c');
%     mnbode(Freq(['OLG_IMC' num2str(ii)]),Abs(['OLG_IMC' num2str(ii)]),Phase(['OLG_IMC' num2str(ii)]),...
%         'linestyle',{'*'})
[~,fitabs] = mntrim(0,1e5,Freq('OLG_IMC'),Abs('OLG_IMC'));
[fitff,fitphase] = mntrim(0,1e5,Freq('OLG_IMC'),Phase('OLG_IMC'));
[H,sigma_H, ~, dt,sigma_dt]...
    = Fit_Opgain(fitff, fitabs,fitphase,...
    Cav, 'IMC', 1e-6, m_AS , doplot);
Cav_LPF = tf(H,[1/Cav('Cpole_IMC')/2/pi 1]);