function [H, sigma_H, Cav_LPF, dt, sigma_dt] = Fit_Hrefcav_0901(TTFSS_Elec, FitServo_0dB, Act, Cav, varargin)

if mnismember(varargin,'Plot')
    doplot = 'Plot';
else
    doplot = 'noPlot';
end

Freq = containers.Map;
Abs = containers.Map;
Phase = containers.Map;
Servo = containers.Map;

% importdata
mnimportdata('O0901_7.txt',Freq,Abs,Phase,'OLG_FSS_PZT_ONLY','tf');

CG = 0;
FG = 0;
fastpol = -1;

Servo('TTFSS_PZT') = FitServo_0dB('TTFSS_PZT')*10^(CG/20)*10^(FG/20)*fastpol;
m_AS = -Servo('TTFSS_PZT')*Act('NPRO_PZT');

[H, sigma_H, Cav_LPF, dt, sigma_dt]...
    = Fit_Opgain(Freq('OLG_FSS_PZT_ONLY'), Abs('OLG_FSS_PZT_ONLY')*-TTFSS_Elec('common_gain1'),...
    Phase('OLG_FSS_PZT_ONLY'), Cav, 'RefCav', -1e-6, m_AS , 'Plot');
