function [H, sigma_H, Cav_LPF, dt, sigma_dt] = Fit_Hrefcav_1122(TTFSS_Elec, FitServo_0dB, Act, Cav, dt, varargin)

if mnismember(varargin,'Plot')
    doplot = 'Plot';
else
    doplot = 'noPlot';
end

Freq = containers.Map;
Abs = containers.Map;
Phase = containers.Map;
Servo = containers.Map;

% importdata
mnimportdata('O1122_1.CSV',Freq,Abs,Phase,'OLG_FSS','tf');
[~,fitAbs] = mntrim(7e4,2e6,Freq('OLG_FSS'),Abs('OLG_FSS'));
[fitff,fitPhase] = mntrim(7e4,2e6,Freq('OLG_FSS'),Phase('OLG_FSS'));


CG = 26;
FG = 30;
fastpol = -1;

Servo('TTFSS_PZT') = FitServo_0dB('TTFSS_PZT')*10^(CG/20)*10^(FG/20)*fastpol;
Servo('TTFSS_EOM') = FitServo_0dB('TTFSS_EOM')*10^(CG/20);
m_AS = -(Servo('TTFSS_PZT')*Act('NPRO_PZT')...
    +Servo('TTFSS_EOM')*Act('BEOM'))*TTFSS_Elec('mixer');

[H, sigma_H, Cav_LPF, dt, sigma_dt]...
    = Fit_Opgain(fitff, fitAbs*-TTFSS_Elec('common_gain1'),...
    fitPhase, Cav, 'RefCav', -6.5e-6, m_AS , 'Plot');
